DoubleMatrix3D (Colt 1.2.0 - API Specification)
Keywords: cern.colt.matrix.DoubleMatrix3D class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## cern.colt.matrix
Class DoubleMatrix3D

    java.lang.Object
      cern.colt.PersistentObject
          cern.colt.matrix.impl.AbstractMatrix
              cern.colt.matrix.impl.AbstractMatrix3D
                  cern.colt.matrix.DoubleMatrix3D

All Implemented Interfaces:
  Cloneable, Serializable

Direct Known Subclasses:
  DenseDoubleMatrix3D, SparseDoubleMatrix3D

public abstract class DoubleMatrix3D
extends AbstractMatrix3D

Abstract base class for 3-d matrices holding `double` elements. First see the package summary and javadoc tree view to get the broad picture.

A matrix has a number of slices, rows and columns, which are assigned upon instance construction - The matrix's size is then `slices()*rows()*columns()`. Elements are accessed via `[slice,row,column]` coordinates. Legal coordinates range from `[0,0,0]` to `[slices()-1,rows()-1,columns()-1]`. Any attempt to access an element at a coordinate `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()` will throw an `IndexOutOfBoundsException`.

Note that this implementation is not synchronized.

Version:
  1.0, 09/24/99
See Also:
  Serialized Form

Field Summary

Fields inherited from class cern.colt.PersistentObject
`serialVersionUID`

Method Summary
`double` | `aggregate(DoubleDoubleFunction aggr, DoubleFunction f)` Applies a function to each cell and aggregates the results.
`double` | `aggregate(DoubleMatrix3D other, DoubleDoubleFunction aggr, DoubleDoubleFunction f)` Applies a function to each corresponding cell of two matrices and aggregates the results.
`DoubleMatrix3D` | `assign(double value)` Sets all cells to the state specified by `value`.
`DoubleMatrix3D` | `assign(double[][][] values)` Sets all cells to the state specified by `values`.
`DoubleMatrix3D` | `assign(DoubleFunction function)` Assigns the result of a function to each cell; `x[slice,row,col] = function(x[slice,row,col])`.
`DoubleMatrix3D` | `assign(DoubleMatrix3D other)` Replaces all cell values of the receiver with the values of another matrix.
`DoubleMatrix3D` | `assign(DoubleMatrix3D y, DoubleDoubleFunction function)` Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.
`int` | `cardinality()` Returns the number of cells having non-zero values; ignores tolerance.
`DoubleMatrix3D` | `copy()` Constructs and returns a deep copy of the receiver.
`boolean` | `equals(double value)` Returns whether all cells are equal to the given value.
`boolean` | `equals(Object obj)` Compares this object against the specified object.
`double` | `get(int slice, int row, int column)` Returns the matrix cell value at coordinate `[slice,row,column]`.
`void` | `getNonZeros(IntArrayList sliceList, IntArrayList rowList, IntArrayList columnList, DoubleArrayList valueList)` Fills the coordinates and values of cells having non-zero values into the specified lists.
`abstract double` | `getQuick(int slice, int row, int column)` Returns the matrix cell value at coordinate `[slice,row,column]`.
`DoubleMatrix3D` | `like()` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same number of slices, rows and columns.
`abstract DoubleMatrix3D` | `like(int slices, int rows, int columns)` Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns.
`void` | `set(int slice, int row, int column, double value)` Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.
`abstract void` | `setQuick(int slice, int row, int column, double value)` Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.
`double[][][]` | `toArray()` Constructs and returns a 2-dimensional array containing the cell values.
`String` | `toString()` Returns a string representation using default formatting.
`DoubleMatrix2D` | `viewColumn(int column)` Constructs and returns a new 2-dimensional slice view representing the slices and rows of the given column.
`DoubleMatrix3D` | `viewColumnFlip()` Constructs and returns a new flip view along the column axis.
`DoubleMatrix3D` | `viewDice(int axis0, int axis1, int axis2)` Constructs and returns a new dice view; Swaps dimensions (axes); Example: 3 x 4 x 5 matrix --> 4 x 3 x 5 matrix.
`DoubleMatrix3D` | `viewPart(int slice, int row, int column, int depth, int height, int width)` Constructs and returns a new sub-range view that is a `depth x height x width` sub matrix starting at `[slice,row,column]`; Equivalent to `view().part(slice,row,column,depth,height,width)`; Provided for convenience only.
`DoubleMatrix2D` | `viewRow(int row)` Constructs and returns a new 2-dimensional slice view representing the slices and columns of the given row.
`DoubleMatrix3D` | `viewRowFlip()` Constructs and returns a new flip view along the row axis.
`DoubleMatrix3D` | `viewSelection(DoubleMatrix2DProcedure condition)` Constructs and returns a new selection view that is a matrix holding all slices matching the given condition.
`DoubleMatrix3D` | `viewSelection(int[] sliceIndexes, int[] rowIndexes, int[] columnIndexes)` Constructs and returns a new selection view that is a matrix holding the indicated cells.
`DoubleMatrix2D` | `viewSlice(int slice)` Constructs and returns a new 2-dimensional slice view representing the rows and columns of the given slice.
`DoubleMatrix3D` | `viewSliceFlip()` Constructs and returns a new flip view along the slice axis.
`DoubleMatrix3D` | `viewSorted(int row, int column)` Sorts the matrix slices into ascending order, according to the natural ordering of the matrix values in the given `[row,column]` position.
`DoubleMatrix3D` | `viewStrides(int sliceStride, int rowStride, int columnStride)` Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell.
`void` | `zAssign27Neighbors(DoubleMatrix3D B, Double27Function function)` 27 neighbor stencil transformation.
`double` | `zSum()` Returns the sum of all cells; `Sum( x[i,j,k] )`.

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix3D
`checkShape, checkShape, columns, rows, size, slices, toStringShort`

Methods inherited from class cern.colt.matrix.impl.AbstractMatrix
`ensureCapacity, trimToSize`

Methods inherited from class cern.colt.PersistentObject
`clone`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### aggregate

    public double aggregate(DoubleDoubleFunction aggr,
                            DoubleFunction f)

  Applies a function to each cell and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(slice,row,column)) )` and terminators are `a(1) == f(get(0,0,0)), a(0)==Double.NaN`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      2 x 2 x 2 matrix
      0 1
      2 3

      4 5
      6 7

      // Sum( x[slice,row,col]*x[slice,row,col] )
      matrix.aggregate(F.plus,F.square);
      --> 140

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell value.
    `f` - a function transforming the current cell value.
  Returns:
    the aggregated measure.
  See Also:
    `Functions`

### aggregate

    public double aggregate(DoubleMatrix3D other,
                            DoubleDoubleFunction aggr,
                            DoubleDoubleFunction f)

  Applies a function to each corresponding cell of two matrices and aggregates the results. Returns a value `v` such that `v==a(size())` where `a(i) == aggr( a(i-1), f(get(slice,row,column),other.get(slice,row,column)) )` and terminators are `a(1) == f(get(0,0,0),other.get(0,0,0)), a(0)==Double.NaN`.

  Example:

      cern.jet.math.Functions F = cern.jet.math.Functions.functions;
      x = 2 x 2 x 2 matrix
      0 1
      2 3

      4 5
      6 7

      y = 2 x 2 x 2 matrix
      0 1
      2 3

      4 5
      6 7

      // Sum( x[slice,row,col] * y[slice,row,col] )
      x.aggregate(y, F.plus, F.mult);
      --> 140

      // Sum( (x[slice,row,col] + y[slice,row,col])^2 )
      x.aggregate(y, F.plus, F.chain(F.square,F.plus));
      --> 560

  For further examples, see the package doc.

  Parameters:
    `aggr` - an aggregation function taking as first argument the current aggregation and as second argument the transformed current cell values.
    `f` - a function transforming the current cell values.
  Returns:
    the aggregated measure.
  Throws:
    `IllegalArgumentException` - if `slices() != other.slices() || rows() != other.rows() || columns() != other.columns()`
  See Also:
    `Functions`

### assign

    public DoubleMatrix3D assign(double[][][] values)

  Sets all cells to the state specified by `values`. `values` is required to have the form `values[slice][row][column]` and have exactly the same number of slices, rows and columns as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Parameters:
    `values` - the values to be filled into the cells.
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `values.length != slices() || for any 0 <= slice < slices(): values[slice].length != rows()`.
    `IllegalArgumentException` - if `for any 0 <= column < columns(): values[slice][row].length != columns()`.

### assign

    public DoubleMatrix3D assign(double value)

  Sets all cells to the state specified by `value`.

  Parameters:
    `value` - the value to be filled into the cells.
  Returns:
    `this` (for convenience only).

### assign

    public DoubleMatrix3D assign(DoubleFunction function)

  Assigns the result of a function to each cell; `x[slice,row,col] = function(x[slice,row,col])`.

  Example:

      matrix = 1 x 2 x 2 matrix
      0.5 1.5
      2.5 3.5

      // change each cell to its sine
      matrix.assign(cern.jet.math.Functions.sin);
      -->
      1 x 2 x 2 matrix
      0.479426  0.997495
      0.598472 -0.350783

  For further examples, see the package doc.

  Parameters:
    `function` - a function object taking as argument the current cell's value.
  Returns:
    `this` (for convenience only).
  See Also:
    `Functions`

### assign

    public DoubleMatrix3D assign(DoubleMatrix3D other)

  Replaces all cell values of the receiver with the values of another matrix. Both matrices must have the same number of slices, rows and columns. If both matrices share the same cells (as is the case if they are views derived from the same matrix) and intersect in an ambiguous way, then replaces as if using an intermediate auxiliary deep copy of `other`.

  Parameters:
    `other` - the source matrix to copy from (may be identical to the receiver).
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `slices() != other.slices() || rows() != other.rows() || columns() != other.columns()`

### assign

    public DoubleMatrix3D assign(DoubleMatrix3D y,
                                 DoubleDoubleFunction function)

  Assigns the result of a function to each cell; `x[row,col] = function(x[row,col],y[row,col])`.

  Example:

      // assign x[row,col] = x[row,col]y[row,col]
      m1 = 1 x 2 x 2 matrix
      0 1
      2 3

      m2 = 1 x 2 x 2 matrix
      0 2
      4 6

      m1.assign(m2, cern.jet.math.Functions.pow);
      -->
      m1 == 1 x 2 x 2 matrix
       1   1
      16 729

  For further examples, see the package doc.

  Parameters:
    `y` - the secondary matrix to operate on.
    `function` - a function object taking as first argument the current cell's value of `this`, and as second argument the current cell's value of `y`,
  Returns:
    `this` (for convenience only).
  Throws:
    `IllegalArgumentException` - if `slices() != other.slices() || rows() != other.rows() || columns() != other.columns()`
  See Also:
    `Functions`

### cardinality

    public int cardinality()

  Returns the number of cells having non-zero values; ignores tolerance.

### copy

    public DoubleMatrix3D copy()

  Constructs and returns a deep copy of the receiver.

  Note that the returned matrix is an independent deep copy. The returned matrix is not backed by this matrix, so changes in the returned matrix are not reflected in this matrix, and vice-versa.

  Returns:
    a deep copy of the receiver.

### equals

    public boolean equals(double value)

  Returns whether all cells are equal to the given value.

  Parameters:
    `value` - the value to test against.
  Returns:
    `true` if all cells are equal to the given value, `false` otherwise.

### equals

    public boolean equals(Object obj)

  Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and is at least a `DoubleMatrix3D` object that has the same number of slices, rows and columns as the receiver and has exactly the same values at the same coordinates.

  Parameters:
    `obj` - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.

### get

    public double get(int slice,
                      int row,
                      int column)

  Returns the matrix cell value at coordinate `[slice,row,column]`.

  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value of the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

### getNonZeros

    public void getNonZeros(IntArrayList sliceList,
                            IntArrayList rowList,
                            IntArrayList columnList,
                            DoubleArrayList valueList)

  Fills the coordinates and values of cells having non-zero values into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists all have a new size, the number of non-zero values.

  In general, fill order is unspecified. This implementation fill like: `for (slice = 0..slices-1) for (row = 0..rows-1) for (column = 0..colums-1) do ...` . However, subclasses are free to us any other order, even an order that may change over time as cell values are changed. (Of course, result lists indexes are guaranteed to correspond to the same cell). For an example, see `DoubleMatrix2D.getNonZeros(IntArrayList,IntArrayList,DoubleArrayList)`.

  Parameters:
    `sliceList` - the list to be filled with slice indexes, can have any size.
    `rowList` - the list to be filled with row indexes, can have any size.
    `columnList` - the list to be filled with column indexes, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### getQuick

    public abstract double getQuick(int slice,
                                    int row,
                                    int column)

  Returns the matrix cell value at coordinate `[slice,row,column]`.

  Provided with invalid parameters this method may return invalid objects without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
  Returns:
    the value at the specified coordinate.

### like

    public DoubleMatrix3D like()

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the same number of slices, rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix3D` the new matrix must also be of type `DenseDoubleMatrix3D`, if the receiver is an instance of type `SparseDoubleMatrix3D` the new matrix must also be of type `SparseDoubleMatrix3D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Returns:
    a new empty matrix of the same dynamic type.

### like

    public abstract DoubleMatrix3D like(int slices,
                                        int rows,
                                        int columns)

  Construct and returns a new empty matrix of the same dynamic type as the receiver, having the specified number of slices, rows and columns. For example, if the receiver is an instance of type `DenseDoubleMatrix3D` the new matrix must also be of type `DenseDoubleMatrix3D`, if the receiver is an instance of type `SparseDoubleMatrix3D` the new matrix must also be of type `SparseDoubleMatrix3D`, etc. In general, the new matrix should have internal parametrization as similar as possible.

  Parameters:
    `slices` - the number of slices the matrix shall have.
    `rows` - the number of rows the matrix shall have.
    `columns` - the number of columns the matrix shall have.
  Returns:
    a new empty matrix of the same dynamic type.

### set

    public void set(int slice,
                    int row,
                    int column,
                    double value)

  Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.

  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.
  Throws:
    `IndexOutOfBoundsException` - if `row<0 || row>=rows() || slice<0 || slice>=slices() || column<0 || column>=column()`.

### setQuick

    public abstract void setQuick(int slice,
                                  int row,
                                  int column,
                                  double value)

  Sets the matrix cell at coordinate `[slice,row,column]` to the specified value.

  Provided with invalid parameters this method may access illegal indexes without throwing any exception. You should only use this method when you are absolutely sure that the coordinate is within bounds. Precondition (unchecked): `slice<0 || slice>=slices() || row<0 || row>=rows() || column<0 || column>=column()`.

  Parameters:
    `slice` - the index of the slice-coordinate.
    `row` - the index of the row-coordinate.
    `column` - the index of the column-coordinate.
    `value` - the value to be filled into the specified cell.

### toArray

    public double[][][] toArray()

  Constructs and returns a 2-dimensional array containing the cell values. The returned array `values` has the form `values[slice][row][column]` and has the same number of slices, rows and columns as the receiver.

  The values are copied. So subsequent changes in `values` are not reflected in the matrix, and vice-versa.

  Returns:
    an array filled with the values of the cells.

### toString

    public String toString()

  Returns a string representation using default formatting.

  See Also:
    `Formatter`

### viewColumn

    public DoubleMatrix2D viewColumn(int column)

  Constructs and returns a new 2-dimensional slice view representing the slices and rows of the given column. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  To obtain a slice view on subranges, construct a sub-ranging view (`view().part(...)`), then apply this method to the sub-range view. To obtain 1-dimensional views, apply this method, then apply another slice view (methods `viewColumn`, `viewRow`) on the intermediate 2-dimensional view. To obtain 1-dimensional views on subranges, apply both steps.

  Parameters:
    `column` - the index of the column to fix.
  Returns:
    a new 2-dimensional slice view.
  Throws:
    `IndexOutOfBoundsException` - if `column < 0 || column >= columns()`.
  See Also:
    `viewSlice(int)`, `viewRow(int)`

### viewColumnFlip

    public DoubleMatrix3D viewColumnFlip()

  Constructs and returns a new flip view along the column axis. What used to be column `0` is now column `columns()-1`, ..., what used to be column `columns()-1` is now column `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Returns:
    a new flip view.
  See Also:
    `viewSliceFlip()`, `viewRowFlip()`

### viewDice

    public DoubleMatrix3D viewDice(int axis0,
                                   int axis1,
                                   int axis2)

  Constructs and returns a new dice view; Swaps dimensions (axes); Example: 3 x 4 x 5 matrix --> 4 x 3 x 5 matrix. The view has dimensions exchanged; what used to be one axis is now another, in all desired permutations. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `axis0` - the axis that shall become axis 0 (legal values 0..2).
    `axis1` - the axis that shall become axis 1 (legal values 0..2).
    `axis2` - the axis that shall become axis 2 (legal values 0..2).
  Returns:
    a new dice view.
  Throws:
    `IllegalArgumentException` - if some of the parameters are equal or not in range 0..2.

### viewPart

    public DoubleMatrix3D viewPart(int slice,
                                   int row,
                                   int column,
                                   int depth,
                                   int height,
                                   int width)

  Constructs and returns a new sub-range view that is a `depth x height x width` sub matrix starting at `[slice,row,column]`; Equivalent to `view().part(slice,row,column,depth,height,width)`; Provided for convenience only. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `slice` - The index of the slice-coordinate.
    `row` - The index of the row-coordinate.
    `column` - The index of the column-coordinate.
    `depth` - The depth of the box.
    `height` - The height of the box.
    `width` - The width of the box.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `slice<0 || depth<0 || slice+depth>slices() || row<0 || height<0 || row+height>rows() || column<0 || width<0 || column+width>columns()`

### viewRow

    public DoubleMatrix2D viewRow(int row)

  Constructs and returns a new 2-dimensional slice view representing the slices and columns of the given row. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  To obtain a slice view on subranges, construct a sub-ranging view (`view().part(...)`), then apply this method to the sub-range view. To obtain 1-dimensional views, apply this method, then apply another slice view (methods `viewColumn`, `viewRow`) on the intermediate 2-dimensional view. To obtain 1-dimensional views on subranges, apply both steps.

  Parameters:
    `row` - the index of the row to fix.
  Returns:
    a new 2-dimensional slice view.
  Throws:
    `IndexOutOfBoundsException` - if `row < 0 || row >= row()`.
  See Also:
    `viewSlice(int)`, `viewColumn(int)`

### viewRowFlip

    public DoubleMatrix3D viewRowFlip()

  Constructs and returns a new flip view along the row axis. What used to be row `0` is now row `rows()-1`, ..., what used to be row `rows()-1` is now row `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Returns:
    a new flip view.
  See Also:
    `viewSliceFlip()`, `viewColumnFlip()`

### viewSelection

    public DoubleMatrix3D viewSelection(int[] sliceIndexes,
                                        int[] rowIndexes,
                                        int[] columnIndexes)

  Constructs and returns a new selection view that is a matrix holding the indicated cells. There holds `view.slices() == sliceIndexes.length, view.rows() == rowIndexes.length, view.columns() == columnIndexes.length` and `view.get(k,i,j) == this.get(sliceIndexes[k],rowIndexes[i],columnIndexes[j])`. Indexes can occur multiple times and can be in arbitrary order. For an example see `DoubleMatrix2D.viewSelection(int[],int[])`.

  Note that modifying the index arguments after this call has returned has no effect on the view. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `sliceIndexes` - The slices of the cells that shall be visible in the new view. To indicate that all slices shall be visible, simply set this parameter to `null`.
    `rowIndexes` - The rows of the cells that shall be visible in the new view. To indicate that all rows shall be visible, simply set this parameter to `null`.
    `columnIndexes` - The columns of the cells that shall be visible in the new view. To indicate that all columns shall be visible, simply set this parameter to `null`.
  Returns:
    the new view.
  Throws:
    `IndexOutOfBoundsException` - if `!(0 <= sliceIndexes[i] < slices())` for any `i=0..sliceIndexes.length()-1`.
    `IndexOutOfBoundsException` - if `!(0 <= rowIndexes[i] < rows())` for any `i=0..rowIndexes.length()-1`.
    `IndexOutOfBoundsException` - if `!(0 <= columnIndexes[i] < columns())` for any `i=0..columnIndexes.length()-1`.

### viewSelection

    public DoubleMatrix3D viewSelection(DoubleMatrix2DProcedure condition)

  Constructs and returns a new selection view that is a matrix holding all slices matching the given condition. Applies the condition to each slice and takes only those where `condition.apply(viewSlice(i))` yields `true`. To match rows or columns, use a dice view.

  Example:

      // extract and view all slices which have an aggregate sum > 1000
      matrix.viewSelection(
         new DoubleMatrix2DProcedure() {
            public final boolean apply(DoubleMatrix2D m) { return m.zSum > 1000; }
         }
      );

  For further examples, see the package doc. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `condition` - The condition to be matched.
  Returns:
    the new view.

### viewSlice

    public DoubleMatrix2D viewSlice(int slice)

  Constructs and returns a new 2-dimensional slice view representing the rows and columns of the given slice. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  To obtain a slice view on subranges, construct a sub-ranging view (`view().part(...)`), then apply this method to the sub-range view. To obtain 1-dimensional views, apply this method, then apply another slice view (methods `viewColumn`, `viewRow`) on the intermediate 2-dimensional view. To obtain 1-dimensional views on subranges, apply both steps.

  Parameters:
    `slice` - the index of the slice to fix.
  Returns:
    a new 2-dimensional slice view.
  Throws:
    `IndexOutOfBoundsException` - if `slice < 0 || slice >= slices()`.
  See Also:
    `viewRow(int)`, `viewColumn(int)`

### viewSliceFlip

    public DoubleMatrix3D viewSliceFlip()

  Constructs and returns a new flip view along the slice axis. What used to be slice `0` is now slice `slices()-1`, ..., what used to be slice `slices()-1` is now slice `0`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Returns:
    a new flip view.
  See Also:
    `viewRowFlip()`, `viewColumnFlip()`

### viewSorted

    public DoubleMatrix3D viewSorted(int row,
                                     int column)

  Sorts the matrix slices into ascending order, according to the natural ordering of the matrix values in the given `[row,column]` position. This sort is guaranteed to be stable. For further information, see `Sorting.sort(DoubleMatrix3D,int,int)`. For more advanced sorting functionality, see `Sorting`.

  Returns:
    a new sorted vector (matrix) view.
  Throws:
    `IndexOutOfBoundsException` - if `row < 0 || row >= rows() || column < 0 || column >= columns()`.

### viewStrides

    public DoubleMatrix3D viewStrides(int sliceStride,
                                      int rowStride,
                                      int columnStride)

  Constructs and returns a new stride view which is a sub matrix consisting of every i-th cell. More specifically, the view has `this.slices()/sliceStride` slices and `this.rows()/rowStride` rows and `this.columns()/columnStride` columns holding cells `this.get(k*sliceStride,i*rowStride,j*columnStride)` for all `k = 0..slices()/sliceStride - 1, i = 0..rows()/rowStride - 1, j = 0..columns()/columnStride - 1`. The returned view is backed by this matrix, so changes in the returned view are reflected in this matrix, and vice-versa.

  Parameters:
    `sliceStride` - the slice step factor.
    `rowStride` - the row step factor.
    `columnStride` - the column step factor.
  Returns:
    a new view.
  Throws:
    `IndexOutOfBoundsException` - if `sliceStride<=0 || rowStride<=0 || columnStride<=0`.

### zAssign27Neighbors

    public void zAssign27Neighbors(DoubleMatrix3D B,
                                   Double27Function function)

  27 neighbor stencil transformation. For efficient finite difference operations. Applies a function to a moving `3 x 3 x 3` window. Does nothing if `rows() < 3 || columns() < 3 || slices() < 3`.

      B[k,i,j] = function.apply(
         A[k-1,i-1,j-1], A[k-1,i-1,j], A[k-1,i-1,j+1],
         A[k-1,i,  j-1], A[k-1,i,  j], A[k-1,i,  j+1],
         A[k-1,i+1,j-1], A[k-1,i+1,j], A[k-1,i+1,j+1],

         A[k  ,i-1,j-1], A[k  ,i-1,j], A[k  ,i-1,j+1],
         A[k  ,i,  j-1], A[k  ,i,  j], A[k  ,i,  j+1],
         A[k  ,i+1,j-1], A[k  ,i+1,j], A[k  ,i+1,j+1],

         A[k+1,i-1,j-1], A[k+1,i-1,j], A[k+1,i-1,j+1],
         A[k+1,i,  j-1], A[k+1,i,  j], A[k+1,i,  j+1],
         A[k+1,i+1,j-1], A[k+1,i+1,j], A[k+1,i+1,j+1]
         )

      x x x -     - x x x     - - - -
      x o x -     - x o x     - - - -
      x x x -     - x x x ... - x x x
      - - - -     - - - -     - x o x
      - - - -     - - - -     - x x x

  Make sure that cells of `this` and `B` do not overlap. In case of overlapping views, behaviour is unspecified.

  Example:

      final double alpha = 0.25;
      final double beta = 0.75;

      cern.colt.function.Double27Function f = new cern.colt.function.Double27Function() {
         public final double apply(
            double a000, double a001, double a002,
            double a010, double a011, double a012,
            double a020, double a021, double a022,

            double a100, double a101, double a102,
            double a110, double a111, double a112,
            double a120, double a121, double a122,

            double a200, double a201, double a202,
            double a210, double a211, double a212,
            double a220, double a221, double a222) {
               return beta*a111 + alpha*(a000 + ... + a222);
            }
      };
      A.zAssign27Neighbors(B,f);

  Parameters:
    `B` - the matrix to hold the results.
    `function` - the function to be applied to the 27 cells.
  Throws:
    `NullPointerException` - if `function==null`.
    `IllegalArgumentException` - if `rows() != B.rows() || columns() != B.columns() || slices() != B.slices()` .

### zSum

    public double zSum()

  Returns the sum of all cells; `Sum( x[i,j,k] )`.

  Returns:
    the sum.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Colt 1.2.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jump to the Colt Homepage